Bug 71628 - ACCESSIBILITY: new UI widget layout start center keyboard navigation, last thumbnail left highlighted when focus is moved away by keyboard [a11y]
Summary: ACCESSIBILITY: new UI widget layout start center keyboard navigation, last th...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
4.2.0.0.alpha0+ Master
Hardware: Other All
: medium normal
Assignee: Not Assigned
QA Contact:
URL:
Whiteboard: target:4.3.0 target:4.2.0
Keywords:
Depends on:
Blocks: Start-Center-Accessibility
  Show dependency treegraph
 
Reported: 2013-11-15 03:38 UTC by V Stuart Foote
Modified: 2016-10-25 19:54 UTC (History)
9 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description V Stuart Foote 2013-11-15 03:38:33 UTC
On Windows 7 sp1 64-bit with Assistive Technology enabled and NVDA in use

Version: 4.2.0.0.alpha1+
Build ID: 868103846b9b32bfecd77c08055fdca69d0265c2
TinderBox: Win-x86@47-TDF, Branch:master, Time: 2013-11-14_23:59:37

The latest start center continues to have a mismatch in function between mouse navigation with mouse over focus, and keyboard traversal.

<F6> navigation toggles between the File menu and the initial GTK+ container holding the Open button. Start center should be restructured such that the <F6> navigation moves from the File --> Open & Templates --> Help & Extentions --> Thumbnail view.  <Shift> <F6> should move the opposite sequence.

GTK+ mouse over events are only firing on the GTK button objects. They do not fire on the thumbnail views -- and more troublesome, focus is not shifted to the object that has received the mouse over event. 

Key board movement seems awkward-- <TAB> movements will cycle focus through all GTK button objects and thumbnail view objects, but Cursor movements are bound to the block of objects. Except that the Help & Extensions block will not traverse with Cursor movements.

Visual focus (the mouse over graphics shift) does not follow keyboard focus. And focus traversal of the thumbnail view leaves the last thumbnail highlighted when <TAB> or <F6> moves focus to other objects.
Comment 1 Jan Holesovsky 2013-11-15 08:17:28 UTC
Stuart: Thank you a lot for the report!  Please - can you split it into separate reports?  Unfortunately it makes things harder when many issues are reported in one bug - it leads to bugs that are never fixed / closed :-(
Comment 2 V Stuart Foote 2013-11-19 00:57:24 UTC
Issues split out into separate bugs as requested.
Bug 71763 - ACCESSIBILITY: new GTK+ UI start center incorrect F6 and F10 key traversal [a11y]
Bug 71764 - ACCESSIBILITY: new GTK+ UI start center incorrect subwindow relationship impacting <TAB> and Cursor movements [a11y]
Bug 71765 - ACCESSIBILITY: new GTK+ UI start center incorrect mouse-over visual focus, program and keyboard focus are not moved [a11y] 

Issue remaining this bug is that focus traversal of the thumbnail view leaves the last thumbnail highlighted when <TAB>, <F6> or <F10> moves focus to other objects.
Comment 3 Arnaud Versini 2013-11-19 11:05:42 UTC
Hi,

Small question, there is GTK+ in the bug title, and Windows 7 in the description. I will remove the gtk+ in the bug title for all those bugs. Ok ?
Comment 4 V Stuart Foote 2013-11-19 14:17:46 UTC
Arnaud,
(In reply to comment #3)
> Hi,
> 
> Small question, there is GTK+ in the bug title, and Windows 7 in the
> description. I will remove the gtk+ in the bug title for all those bugs. Ok ?

Please do not. The fundamental issue arrises because of adoption of GTK+ UI design and widgets. https://wiki.documentfoundation.org/Development/WidgetLayout#Rationale

While efficient from a design and maintenance perspective, the challenge is making this all work consistently cross platform--notably the correct keyboard navigation needed for use by Assistive Technologies tools.

The UI widget framework is GTK+, all OS are affected--issue is correct as titled. But additional reivew on OS X and Linux still useful.

Stuart
Comment 5 Arnaud Versini 2013-11-19 14:54:41 UTC
We don't use GTK on platform other than Unix (Linux, BSD...). The change is we use the same file format (convenient for Glade) for storing graphical interface, like the new start center(.ui), and use gnome standards.

This issue as you said is not GTK+ related. GTK+ for me is for issue related to the VCL GTK+. That's why I think GTK+ is not related to this issue, joren, jmaderon, do you agree ?
Comment 6 V Stuart Foote 2013-11-19 15:45:54 UTC
On Fedora 19 64-bit kernel 3.10.11-200.fc19.x86_64
Version: 4.2.0.0.alpha1+
Build ID: f99736820a23cb7e37139607713658dea1c69dd4
TinderBox: Linux-rpm_deb-x86_64@46-TDF, Branch:master, Time: 2013-11-17_23:56:22

Verified issues are present on Linux builds of LODev4.2.0alpha1+
Comment 7 V Stuart Foote 2013-11-19 16:05:05 UTC
Arnaud,
(In reply to comment #5)
> This issue as you said is not GTK+ related. GTK+ for me is for issue related
> to the VCL GTK+.

Conceded and changed...

Stuart
Comment 8 Arnaud Versini 2013-11-20 13:20:48 UTC
Thanks, it is just to be sure the title is correct and bug is not Linux specific :-)
Comment 9 Commit Notification 2014-01-09 14:45:10 UTC
Zolnai Tamas committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=0314034d8b23d5b69399cfcdf6b2f2add73f9f47

fdo#71628 Startcenter: remove thumbnail selection when focus is moved away



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 10 Commit Notification 2014-01-09 17:26:54 UTC
Zolnai Tamas committed a patch related to this issue.
It has been pushed to "libreoffice-4-2":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=a55ec81ad75b280edea8aa30f2a31a14489d2036&h=libreoffice-4-2

fdo#71628 Startcenter: remove thumbnail selection when focus is moved away


It will be available in LibreOffice 4.2.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 11 Commit Notification 2014-01-13 12:19:53 UTC
Zolnai Tamas committed a patch related to this issue.
It has been pushed to "libreoffice-4-2-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=1c83930c80b2096a12b84a848a7261dcfe9e9931&h=libreoffice-4-2-0

fdo#71628 Startcenter: remove thumbnail selection when focus is moved away


It will be available already in LibreOffice 4.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 12 V Stuart Foote 2014-01-16 02:28:42 UTC
Confirming resolved fixed on LODev 4.2.1 and master, expect it will be fine on the next 4.2.0 RC build.

Version: 4.3.0.0.alpha0+
Build ID: 17a8b2ed7cff9dd11911cd3176679bf809a174d7
TinderBox: Win-x86@39, Branch:master, Time: 2014-01-15_01:30:28

Version: 4.2.1.0.0+
Build ID: 2158a26f25b67fdd2564d2e01c2a0a720ef7f2e1
TinderBox: Win-x86@42, Branch:libreoffice-4-2, Time: 2014-01-15_12:35:37